Imports System.Runtime.Serialization
Imports System.Text
Imports System.Threading.Tasks
Imports System.Xml.Serialization

Namespace HalMediaType
	Public Interface ILinkedResourceCollection
		Sub Add(ByVal resource As LinkedResource)
	End Interface

	Public Class LinkedResourceCollection(Of T As LinkedResource)
		Inherits LinkedResource
		Implements ILinkedResourceCollection, ICollection(Of T)

		Private innerList As New List(Of T)

		Public Sub Add(ByVal item As T) Implements ICollection(Of T).Add
			Me.innerList.Add(item)
		End Sub

		Public Sub Clear() Implements ICollection(Of T).Clear
			Me.innerList.Clear()
		End Sub

		Public Function Contains(ByVal item As T) As Boolean Implements ICollection(Of T).Contains
			Return Me.innerList.Contains(item)
		End Function

		Public Sub CopyTo(ByVal array() As T, ByVal arrayIndex As Integer) Implements ICollection(Of T).CopyTo
			Me.innerList.CopyTo(array, arrayIndex)
		End Sub

		Public ReadOnly Property Count As Integer Implements ICollection(Of T).Count
			Get
				Return Me.innerList.Count
			End Get
		End Property

		Public ReadOnly Property IsReadOnly As Boolean Implements ICollection(Of T).IsReadOnly
			Get
				Return False
			End Get
		End Property

		Public Function Remove(ByVal item As T) As Boolean Implements ICollection(Of T).Remove
			Return Me.innerList.Remove(item)
		End Function

		Public Function GetEnumerator() As IEnumerator(Of T) Implements IEnumerable(Of T).GetEnumerator
			Return Me.innerList.GetEnumerator
		End Function

		Private Function IEnumerable_GetEnumerator() As System.Collections.IEnumerator Implements System.Collections.IEnumerable.GetEnumerator
			Return Me.innerList.GetEnumerator
		End Function

		Public Sub Add(ByVal resource As LinkedResource) Implements ILinkedResourceCollection.Add
			Me.innerList.Add(CType(resource, T))
		End Sub
	End Class
End Namespace
